! ::: 
! ::: -----------------------------------------------------------
! :::
      
      subroutine ca_hypfill(adv,adv_l1,adv_l2,adv_l3,adv_h1,adv_h2,adv_h3,&
                           domlo,domhi,delta,xlo,time,bc)
 
      use eos_module
      use probdata_module
      use network, only : nspec,naux
      use meth_params_module, only : NVAR,URHO,UTEMP,UMX,UMY,UMZ,UEDEN,UEINT,UFS,UFX

      implicit none
      include 'bc_types.fi'

      integer          :: adv_l1,adv_l2,adv_l3,adv_h1,adv_h2,adv_h3
      integer          :: bc(3,2,*)
      integer          :: domlo(3), domhi(3)
      double precision :: delta(3), xlo(3), time
      double precision :: adv(adv_l1:adv_h1,adv_l2:adv_h2,adv_l3:adv_h3,NVAR)

      integer          :: i,j,k,n
      integer          :: pt_index(3)
      double precision :: pres,xn(nspec+naux)

      do n = 1,NVAR
         call filcc(adv(adv_l1,adv_l2,adv_l3,n),adv_l1,adv_l2,adv_l3,&
                    adv_h1,adv_h2,adv_h3,domlo,domhi,delta,xlo,bc(1,1,n))
      enddo

      ! This should take care of the outflow condition at lo x.
      if ( bc(1,1,1).eq. FOEXTRAP .and. adv_l1.lt.domlo(1)) then
         !$OMP PARALLEL DO PRIVATE(i,j,k,n,pt_index,pres)
         do k = adv_l3,adv_h3
         do j = adv_l2,adv_h2
         do i = adv_l1, domlo(1)-1
             adv(i,j,k,URHO)  = hse_rho(npts_model)
             adv(i,j,k,UTEMP) = hse_t(npts_model)

             ! First set to "X" not "rho X" for use in EOS
             adv(i,j,k,UFS) = 0.5d0
             adv(i,j,k,UFS+1) = 0.5d0
             do n = 3,7
                adv(i,j,k,UFS+n-1) = 0.d0
             end do
             adv(i,j,k,UFX  ) = 0.5d0
             adv(i,j,k,UFX+1) = bea_fuel
             adv(i,j,k,UFX+2) = abar_fuel

             pt_index(1) = i
             pt_index(2) = j
             pt_index(3) = k

             xn(1:nspec)  = adv(i,j,k,UFS:UFS+nspec-1)
             if (naux > 0) &
                  xn(nspec+1:nspec+naux) = adv(i,j,k,UFX:UFX+naux-1)

             call eos_given_RTX(adv(i,j,k,UEINT),pres,adv(i,j,k,URHO), &
                                adv(i,j,k,UTEMP),xn,pt_index)

             adv(i,j,k,UMX  ) = 0.d0
             adv(i,j,k,UMY  ) = 0.d0
             adv(i,j,k,UMZ  ) = 0.d0
             adv(i,j,k,UEINT) = adv(i,j,k,UEINT)*adv(i,j,k,URHO)
             adv(i,j,k,UEDEN) = adv(i,j,k,UEINT)  &
                   +0.5d0*( adv(i,j,k,UMX)**2 + adv(i,j,k,UMY)**2 &
                           +adv(i,j,k,UMZ)**2 )/adv(i,j,k,URHO)

             ! Now set these to "rho * X"
             do n = 1,nspec
                adv(i,j,k,UFS+n-1) = hse_rho(npts_model)*adv(i,j,k,UFS+n-1)
             end do
             do n = 1,naux
                adv(i,j,k,UFX+n-1) = hse_rho(npts_model)*adv(i,j,k,UFX+n-1)
             end do
         end do
         end do
         end do
         !$OMP END PARALLEL DO
      end if

      ! This should take care of the outflow condition at hi x.
      if ( bc(1,2,1).eq. FOEXTRAP .and. adv_h1.gt.domhi(1)) then
         !$OMP PARALLEL DO PRIVATE(i,j,k,n,pt_index,pres)
         do k = adv_l3,adv_h3
         do j = adv_l2,adv_h2
         do i = domhi(1)+1, adv_h1
             adv(i,j,k,URHO)  = hse_rho(npts_model)
             adv(i,j,k,UTEMP) = hse_t(npts_model)

             ! First set to "X" not "rho X" for use in EOS
             adv(i,j,k,UFS) = 0.5d0
             adv(i,j,k,UFS+1) = 0.5d0
             do n = 3,7
                adv(i,j,k,UFS+n-1) = 0.d0
             end do
             adv(i,j,k,UFX  ) = 0.5d0
             adv(i,j,k,UFX+1) = bea_fuel
             adv(i,j,k,UFX+2) = abar_fuel

             pt_index(1) = i
             pt_index(2) = j
             pt_index(3) = k

             xn(1:nspec)  = adv(i,j,k,UFS:UFS+nspec-1)
             if (naux > 0) &
                  xn(nspec+1:nspec+naux) = adv(i,j,k,UFX:UFX+naux-1)

             call eos_given_RTX(adv(i,j,k,UEINT),pres,adv(i,j,k,URHO), &
                                adv(i,j,k,UTEMP),xn,pt_index)

             adv(i,j,k,UMX  ) = 0.d0
             adv(i,j,k,UMY  ) = 0.d0
             adv(i,j,k,UMZ  ) = 0.d0
             adv(i,j,k,UEINT) = adv(i,j,k,UEINT)*adv(i,j,k,URHO)
             adv(i,j,k,UEDEN) = adv(i,j,k,UEINT)  &
                   +0.5d0*( adv(i,j,k,UMX)**2 + adv(i,j,k,UMY)**2 &
                           +adv(i,j,k,UMZ)**2 )/adv(i,j,k,URHO)

             ! Now set these to "rho * X"
             do n = 1,nspec
                adv(i,j,k,UFS+n-1) = hse_rho(npts_model)*adv(i,j,k,UFS+n-1)
             end do
             do n = 1,naux
                adv(i,j,k,UFX+n-1) = hse_rho(npts_model)*adv(i,j,k,UFX+n-1)
             end do
         end do
         end do
         end do
         !$OMP END PARALLEL DO
      end if

      ! This should take care of the outflow condition at lo y.
      if ( bc(2,1,1).eq. FOEXTRAP .and. adv_l2.lt.domlo(2)) then
         !$OMP PARALLEL DO PRIVATE(i,j,k,n,pt_index,pres)
         do k = adv_l3,adv_h3
         do j = adv_l2, domlo(2)-1
         do i = adv_l1,adv_h1
             adv(i,j,k,URHO)  = hse_rho(npts_model)
             adv(i,j,k,UTEMP) = hse_t(npts_model)

             ! First set to "X" not "rho X" for use in EOS
             adv(i,j,k,UFS) = 0.5d0
             adv(i,j,k,UFS+1) = 0.5d0
             do n = 3,7
                adv(i,j,k,UFS+n-1) = 0.d0
             end do
             adv(i,j,k,UFX  ) = 0.5d0
             adv(i,j,k,UFX+1) = bea_fuel
             adv(i,j,k,UFX+2) = abar_fuel

             pt_index(1) = i
             pt_index(2) = j
             pt_index(3) = k

             xn(1:nspec)  = adv(i,j,k,UFS:UFS+nspec-1)
             if (naux > 0) &
                  xn(nspec+1:nspec+naux) = adv(i,j,k,UFX:UFX+naux-1)

             call eos_given_RTX(adv(i,j,k,UEINT),pres,adv(i,j,k,URHO), &
                                adv(i,j,k,UTEMP),xn,pt_index)

             adv(i,j,k,UMX  ) = 0.d0
             adv(i,j,k,UMY  ) = 0.d0
             adv(i,j,k,UMZ  ) = 0.d0
             adv(i,j,k,UEINT) = adv(i,j,k,UEINT)*adv(i,j,k,URHO)
             adv(i,j,k,UEDEN) = adv(i,j,k,UEINT)  &
                   +0.5d0*( adv(i,j,k,UMX)**2 + adv(i,j,k,UMY)**2 &
                           +adv(i,j,k,UMZ)**2 )/adv(i,j,k,URHO)

             ! Now set these to "rho * X"
             do n = 1,nspec
                adv(i,j,k,UFS+n-1) = hse_rho(npts_model)*adv(i,j,k,UFS+n-1)
             end do
             do n = 1,naux
                adv(i,j,k,UFX+n-1) = hse_rho(npts_model)*adv(i,j,k,UFX+n-1)
             end do
         end do
         end do
         end do
         !$OMP END PARALLEL DO
      end if

      ! This should take care of the outflow condition at hi y.
      if ( bc(2,2,1).eq. FOEXTRAP .and. adv_h2.gt.domhi(2)) then
         !$OMP PARALLEL DO PRIVATE(i,j,k,n,pt_index,pres)
         do k = adv_l3,adv_h3
         do j = domhi(2)+1, adv_h2
         do i = adv_l1,adv_h1
             adv(i,j,k,URHO)  = hse_rho(npts_model)
             adv(i,j,k,UTEMP) = hse_t(npts_model)

             ! First set to "X" not "rho X" for use in EOS
             adv(i,j,k,UFS) = 0.5d0
             adv(i,j,k,UFS+1) = 0.5d0
             do n = 3,7
                adv(i,j,k,UFS+n-1) = 0.d0
             end do
             adv(i,j,k,UFX  ) = 0.5d0
             adv(i,j,k,UFX+1) = bea_fuel
             adv(i,j,k,UFX+2) = abar_fuel

             pt_index(1) = i
             pt_index(2) = j
             pt_index(3) = k

             xn(1:nspec)  = adv(i,j,k,UFS:UFS+nspec-1)
             if (naux > 0) &
                  xn(nspec+1:nspec+naux) = adv(i,j,k,UFX:UFX+naux-1)

             call eos_given_RTX(adv(i,j,k,UEINT),pres,adv(i,j,k,URHO), &
                                adv(i,j,k,UTEMP),xn,pt_index)

             adv(i,j,k,UMX  ) = 0.d0
             adv(i,j,k,UMY  ) = 0.d0
             adv(i,j,k,UMZ  ) = 0.d0
             adv(i,j,k,UEINT) = adv(i,j,k,UEINT)*adv(i,j,k,URHO)
             adv(i,j,k,UEDEN) = adv(i,j,k,UEINT)  &
                   +0.5d0*( adv(i,j,k,UMX)**2 + adv(i,j,k,UMY)**2 &
                           +adv(i,j,k,UMZ)**2 )/adv(i,j,k,URHO)

             ! Now set these to "rho * X"
             do n = 1,nspec
                adv(i,j,k,UFS+n-1) = hse_rho(npts_model)*adv(i,j,k,UFS+n-1)
             end do
             do n = 1,naux
                adv(i,j,k,UFX+n-1) = hse_rho(npts_model)*adv(i,j,k,UFX+n-1)
             end do
         end do
         end do
         end do
         !$OMP END PARALLEL DO
      end if

      ! This should take care of the outflow condition at lo z.
      if ( bc(3,1,1).eq. FOEXTRAP .and. adv_l3.lt.domlo(3)) then
         !$OMP PARALLEL DO PRIVATE(i,j,k,n,pt_index,pres)
         do k = adv_l3, domlo(3)-1
         do j = adv_l2,adv_h2
         do i = adv_l1,adv_h1
             adv(i,j,k,URHO)  = hse_rho(npts_model)
             adv(i,j,k,UTEMP) = hse_t(npts_model)

             ! First set to "X" not "rho X" for use in EOS
             adv(i,j,k,UFS) = 0.5d0
             adv(i,j,k,UFS+1) = 0.5d0
             do n = 3,7
                adv(i,j,k,UFS+n-1) = 0.d0
             end do
             adv(i,j,k,UFX  ) = 0.5d0
             adv(i,j,k,UFX+1) = bea_fuel
             adv(i,j,k,UFX+2) = abar_fuel

             pt_index(1) = i
             pt_index(2) = j
             pt_index(3) = k

             xn(1:nspec)  = adv(i,j,k,UFS:UFS+nspec-1)
             if (naux > 0) &
                  xn(nspec+1:nspec+naux) = adv(i,j,k,UFX:UFX+naux-1)

             call eos_given_RTX(adv(i,j,k,UEINT),pres,adv(i,j,k,URHO), &
                                adv(i,j,k,UTEMP),xn,pt_index)

             adv(i,j,k,UMX  ) = 0.d0
             adv(i,j,k,UMY  ) = 0.d0
             adv(i,j,k,UMZ  ) = 0.d0
             adv(i,j,k,UEINT) = adv(i,j,k,UEINT)*adv(i,j,k,URHO)
             adv(i,j,k,UEDEN) = adv(i,j,k,UEINT)  &
                   +0.5d0*( adv(i,j,k,UMX)**2 + adv(i,j,k,UMY)**2 &
                           +adv(i,j,k,UMZ)**2 )/adv(i,j,k,URHO)

             ! Now set these to "rho * X"
             do n = 1,nspec
                adv(i,j,k,UFS+n-1) = hse_rho(npts_model)*adv(i,j,k,UFS+n-1)
             end do
             do n = 1,naux
                adv(i,j,k,UFX+n-1) = hse_rho(npts_model)*adv(i,j,k,UFX+n-1)
             end do
         end do
         end do
         end do
         !$OMP END PARALLEL DO
      end if

      ! This should take care of the outflow condition at hi z.
      if ( bc(3,2,1).eq. FOEXTRAP .and. adv_h3.gt.domhi(3)) then
         !$OMP PARALLEL DO PRIVATE(i,j,k,n,pt_index,pres)
         do j = adv_l2,adv_h2
         do i = adv_l1,adv_h1
         do k = domhi(3)+1, adv_h3
             adv(i,j,k,URHO)  = hse_rho(npts_model)
             adv(i,j,k,UTEMP) = hse_t(npts_model)

             ! First set to "X" not "rho X" for use in EOS
             adv(i,j,k,UFS) = 0.5d0
             adv(i,j,k,UFS+1) = 0.5d0
             do n = 3,7
                adv(i,j,k,UFS+n-1) = 0.d0
             end do
             adv(i,j,k,UFX  ) = 0.5d0
             adv(i,j,k,UFX+1) = bea_fuel
             adv(i,j,k,UFX+2) = abar_fuel

             pt_index(1) = i
             pt_index(2) = j
             pt_index(3) = k

             xn(1:nspec)  = adv(i,j,k,UFS:UFS+nspec-1)
             if (naux > 0) &
                  xn(nspec+1:nspec+naux) = adv(i,j,k,UFX:UFX+naux-1)

             call eos_given_RTX(adv(i,j,k,UEINT),pres,adv(i,j,k,URHO), &
                                adv(i,j,k,UTEMP),xn,pt_index)

             adv(i,j,k,UMX  ) = 0.d0
             adv(i,j,k,UMY  ) = 0.d0
             adv(i,j,k,UMZ  ) = 0.d0
             adv(i,j,k,UEINT) = adv(i,j,k,UEINT)*adv(i,j,k,URHO)
             adv(i,j,k,UEDEN) = adv(i,j,k,UEINT)  &
                   +0.5d0*( adv(i,j,k,UMX)**2 + adv(i,j,k,UMY)**2 &
                           +adv(i,j,k,UMZ)**2 )/adv(i,j,k,URHO)

             ! Now set these to "rho * X"
             do n = 1,nspec
                adv(i,j,k,UFS+n-1) = hse_rho(npts_model)*adv(i,j,k,UFS+n-1)
             end do
             do n = 1,naux
                adv(i,j,k,UFX+n-1) = hse_rho(npts_model)*adv(i,j,k,UFX+n-1)
             end do
         end do
         end do
         end do
         !$OMP END PARALLEL DO
      end if

      end subroutine ca_hypfill

! ::: 
! ::: -----------------------------------------------------------
! :::
      
      subroutine ca_zerofill(adv,adv_l1,adv_l2,adv_l3,adv_h1,adv_h2,adv_h3,&
                             domlo,domhi,delta,xlo,time,bc)
 
      use eos_module
      use probdata_module
      use network, only : nspec,naux
      use meth_params_module, only : NVAR,URHO,UMX,UMY,UMZ

      implicit none
      include 'bc_types.fi'

      integer          :: adv_l1,adv_l2,adv_l3,adv_h1,adv_h2,adv_h3
      integer          :: bc(3,2,*)
      integer          :: domlo(3), domhi(3)
      double precision :: delta(3), xlo(3), time
      double precision :: adv(adv_l1:adv_h1,adv_l2:adv_h2,adv_l3:adv_h3)

      integer          :: i,j,k

      call filcc(adv(adv_l1,adv_l2,adv_l3),adv_l1,adv_l2,adv_l3,&
                 adv_h1,adv_h2,adv_h3,domlo,domhi,delta,xlo,bc(1,1,1))

      ! This should take care of the outflow condition at lo x.
      if ( bc(1,1,1).eq. FOEXTRAP .and. adv_l1.lt.domlo(1)) then
         do k = adv_l3,adv_h3
         do j = adv_l2,adv_h2
         do i = adv_l1, domlo(1)-1
             adv(i,j,k) = 0.d0
         end do
         end do
         end do
      end if

      ! This should take care of the outflow condition at hi x.
      if ( bc(1,2,1).eq. FOEXTRAP .and. adv_h1.gt.domhi(1)) then
         do k = adv_l3,adv_h3
         do j = adv_l2,adv_h2
         do i = domhi(1)+1, adv_h1
             adv(i,j,k) = 0.d0
         end do
         end do
         end do
      end if

      ! This should take care of the outflow condition at lo y.
      if ( bc(2,1,1).eq. FOEXTRAP .and. adv_l2.lt.domlo(2)) then
         do k = adv_l3,adv_h3
         do j = adv_l2, domlo(2)-1
         do i = adv_l1,adv_h1
             adv(i,j,k) = 0.d0
         end do
         end do
         end do
      end if

      ! This should take care of the outflow condition at hi y.
      if ( bc(2,2,1).eq. FOEXTRAP .and. adv_h2.gt.domhi(2)) then
         do k = adv_l3,adv_h3
         do j = domhi(2)+1, adv_h2
         do i = adv_l1,adv_h1
             adv(i,j,k) = 0.d0
         end do
         end do
         end do
      end if

      ! This should take care of the outflow condition at lo z.
      if ( bc(3,1,1).eq. FOEXTRAP .and. adv_l3.lt.domlo(3)) then
         do k = adv_l3, domlo(3)-1
         do j = adv_l2,adv_h2
         do i = adv_l1,adv_h1
             adv(i,j,k) = 0.d0
         end do
         end do
         end do
      end if

      ! This should take care of the outflow condition at hi z.
      if ( bc(3,2,1).eq. FOEXTRAP .and. adv_h3.gt.domhi(3)) then
         do j = adv_l2,adv_h2
         do i = adv_l1,adv_h1
         do k = domhi(3)+1, adv_h3
             adv(i,j,k) = 0.d0
         end do
         end do
         end do
      end if

      end subroutine ca_zerofill

! ::: -----------------------------------------------------------

      subroutine ca_denfill(adv,adv_l1,adv_l2,adv_l3,adv_h1,adv_h2,adv_h3,&
                            domlo,domhi,delta,xlo,time,bc)

      use probdata_module
      implicit none
      include 'bc_types.fi'

      integer          :: adv_l1,adv_l2,adv_l3,adv_h1,adv_h2,adv_h3
      integer          :: bc(3,2,*)
      integer          :: domlo(3), domhi(3)
      double precision :: delta(3), xlo(3), time
      double precision :: adv(adv_l1:adv_h1,adv_l2:adv_h2,adv_l3:adv_h3)

      integer :: i,j,k

      call filcc(adv,adv_l1,adv_l2,adv_l3,adv_h1,adv_h2,adv_h3,domlo,domhi,delta,xlo,bc)

      ! This should take care of the outflow condition at lo x.
      if ( bc(1,1,1).eq. FOEXTRAP .and. adv_l1.lt.domlo(1)) then
         do k = adv_l3,adv_h3
         do j = adv_l2,adv_h2
         do i = adv_l1,domlo(1)-1
            adv(i,j,k) = hse_rho(npts_model)
         end do
         end do
         end do
      end if

      ! This should take care of the outflow condition at hi x.
      if ( bc(1,2,1).eq. FOEXTRAP .and. adv_h1.gt.domhi(1)) then
         do k = adv_l3,adv_h3
         do j = adv_l2,adv_h2
         do i = domhi(1)+1, adv_h1
            adv(i,j,k) = hse_rho(npts_model)
         end do
         end do
         end do
      end if

      ! This should take care of the outflow condition at lo y.
      if ( bc(2,1,1).eq. FOEXTRAP .and. adv_l2.lt.domlo(2)) then
         do k = adv_l3,adv_h3
         do j = adv_l2,domlo(2)-1
         do i = adv_l1,adv_h1
            adv(i,j,k) = hse_rho(npts_model)
         end do
         end do
         end do
      end if

      ! This should take care of the outflow condition at hi y.
      if ( bc(2,2,1).eq. FOEXTRAP .and. adv_h2.gt.domhi(2)) then
         do k = adv_l3,adv_h3
         do j = domhi(2)+1,adv_h2
         do i = adv_l1,adv_h1
            adv(i,j,k) = hse_rho(npts_model)
         end do
         end do
         end do
      end if

      ! This should take care of the outflow condition at lo z.
      if ( bc(3,1,1).eq. FOEXTRAP .and. adv_l3.lt.domlo(3)) then
         do k = adv_l3,domlo(3)-1
         do j = adv_l2,adv_h2
         do i = adv_l1,adv_h1
            adv(i,j,k) = hse_rho(npts_model)
         end do
         end do
         end do
      end if

      ! This should take care of the outflow condition at hi z.
      if ( bc(3,2,1).eq. FOEXTRAP .and. adv_h3.gt.domhi(3)) then
         do k = domhi(3)+1, adv_h3
         do j = adv_l2,adv_h2
         do i = adv_l1,adv_h1
            adv(i,j,k) = hse_rho(npts_model)
         end do
         end do
         end do
      end if

      end subroutine ca_denfill

! ::: 
! ::: -----------------------------------------------------------
! :::
      
      subroutine ca_default_fill(adv,adv_l1,adv_l2,adv_l3,adv_h1,adv_h2,adv_h3,&
                                 domlo,domhi,delta,xlo,time,bc)
 
      use probdata_module

      implicit none
      include 'bc_types.fi'

      integer          :: adv_l1,adv_l2,adv_l3,adv_h1,adv_h2,adv_h3
      integer          :: bc(3,2,*)
      integer          :: domlo(3), domhi(3)
      double precision :: delta(3), xlo(3), time
      double precision :: adv(adv_l1:adv_h1,adv_l2:adv_h2,adv_l3:adv_h3)

      integer          :: k,n

      call filcc(adv(adv_l1,adv_l2,adv_l3),adv_l1,adv_l2,adv_l3,&
                 adv_h1,adv_h2,adv_h3,domlo,domhi,delta,xlo,bc(1,1,1))

      do n = 1,3 
         do k = 1,2 
            if ( bc(n,k,1).eq. EXT_DIR) then
               print *,'Error in ca_default_fill, bc set to EXT_DIR ',n,k
               stop
            end if
         end do
      end do

      end subroutine ca_default_fill

