module probdata_module

!     These determine the refinement criteria
      double precision, save :: denerr0, denerr1, denerr2, denerr3, dengrad, denthreshold
      double precision, save :: temperr, tempgrad
      double precision, save :: velerr,  velgrad
      double precision, save :: presserr,pressgrad
      double precision, save :: raderr, radgrad
      double precision, save :: specerr, specgrad
      integer         , save :: max_denerr_lev   ,max_dengrad_lev
      integer         , save :: max_temperr_lev   ,max_tempgrad_lev
      integer         , save :: max_velerr_lev   ,max_velgrad_lev
      integer         , save :: max_presserr_lev, max_pressgrad_lev
      integer         , save :: max_raderr_lev, max_radgrad_lev
      integer         , save :: max_specerr_lev, max_specgrad_lev

      ! make the number of points in the model, and the modelname, enter through the probin file
      integer            , save :: npts_model
      character (len=80), save  :: model_name

      ! arrange storage for read_in model--not worrying about efficiency, since this will only be called once
      double precision, allocatable, save ::  model_r(:), model_rho(:)
      double precision, allocatable, save ::  model_t(:), model_p(:)
      double precision, allocatable, save ::  model_s1(:), model_s2(:), model_s3(:)
      double precision, allocatable, save ::  model_grav(:)
      double precision, allocatable, save ::  hse_r(:), hse_rho(:)
      double precision, allocatable, save ::  hse_t(:), hse_p(:)
      double precision, allocatable, save ::  hse_s(:,:),hse_mass(:)


      ! flame width and speed
      double precision, save ::  flogrho(17), f_width(17), f_vel(17)
      ! laminar flame information
      double precision, save :: l_logrho(11), l_vel(11)

      double precision, save ::  center(3)
      double precision, save ::  ash_center(3), ash_radius
      double precision, save :: ash_x, ash_y, ash_z

     ! FLAME PARAMETERS
      integer         , save :: flame_thickening_factor
      double precision, save :: flamevel
      double precision, save :: taudiv
      double precision, save :: bea_fuel, abar_fuel
      logical,          save :: zero_velocity_field

     !   Data for spherical harmonic perturbation
      integer,    parameter  :: lmodemin = 14, lmodemax = 20
      double precision, save :: alphalm(lmodemin:lmodemax,0:lmodemax)
      double precision, save :: betalm(lmodemin:lmodemax,0:lmodemax)
      double precision, save :: gammalm(lmodemin:lmodemax,0:lmodemax)
     !   data to control form of initial pertubation
      integer         , save :: include_random, iextend_pert
      double precision, save :: pertmag


end module probdata_module
