     
      subroutine sponge(uout,uout_l1,uout_l2,uout_l3,&
                        uout_h1,uout_h2,uout_h3,lo,hi,dt)

      use bl_constants_module, only : M_PI
      use meth_params_module , only : NVAR, URHO, UMX, UMY, UMZ, UEDEN

      implicit none
      integer          :: lo(3), hi(3)
      integer          :: uout_l1,uout_l2,uout_l3,uout_h1,uout_h2,uout_h3
      double precision :: uout(uout_l1:uout_h1,uout_l2:uout_h2,uout_l3:uout_h3,NVAR)
      double precision :: dt

      integer          :: i,j,k
      double precision :: rho, ke_old, ke_new, fac, sponge_mult

      double precision, parameter :: sponge_weighting = 1000.d0

      !$OMP PARALLEL DO PRIVATE(i,j,k,rho,fac,sponge_mult,ke_old,ke_new)
      do k = lo(3),hi(3)
      do j = lo(2),hi(2)
      do i = lo(1),hi(1)

         rho = uout(i,j,k,URHO)

         if (rho .le. 100.0d0) then

            if (rho < 1.d-4) then
               fac =  1.d0
            else 
               fac =  0.5d0*(1.d0 - cos(M_PI*(rho - 100.0d0)/(1.d-4 - 100.0d0)))
            end if

            sponge_mult = 1.d0 / (1.d0 + fac * sponge_weighting * dt)

            ke_old = 0.5d0 * ( uout(i,j,k,UMX)**2 + uout(i,j,k,UMY)**2 &
                              +uout(i,j,k,UMZ)**2 )/ rho

            uout(i,j,k,UMX  ) = uout(i,j,k,UMX  ) * sponge_mult
            uout(i,j,k,UMY  ) = uout(i,j,k,UMY  ) * sponge_mult
            uout(i,j,k,UMZ  ) = uout(i,j,k,UMZ  ) * sponge_mult

            ke_new = 0.5d0 * ( uout(i,j,k,UMX)**2 + uout(i,j,k,UMY)**2 &
                              +uout(i,j,k,UMZ)**2 )/ rho

            uout(i,j,k,UEDEN) = uout(i,j,k,UEDEN) + (ke_new-ke_old)

         end if

      enddo
      enddo
      enddo
      !$OMP END PARALLEL DO

      end subroutine sponge

